<script setup lang="ts">
import { usePromotionStore } from '@/stores/promotion'
import { ref, computed } from 'vue'
import { useReceiptStore } from '@/stores/receipt'
import { useCustomerStore } from '@/stores/customer'

const PromotionStore = usePromotionStore()
const ReceiptStore = useReceiptStore()
const customerStore = useCustomerStore()
const pointAmountStore = customerStore.currentCustomer?.pointAmount ?? 0

const checkPromotion = computed(() => {
  return PromotionStore.promotions.filter(
    (promotion) => promotion.status === 'Active' && promotion.pointUse <= pointAmountStore
  ) // customerStore.currentCustomer?.poi0ntAmount
})

const cancelDialog = () => {
  PromotionStore.promotionDialog = false
}

const savePromotions = () => {
  const selectedPromotions = checkPromotion.value.filter((promotion) => promotion.selected)
  const totalDiscount = selectedPromotions.reduce((sum, promotion) => sum + promotion.discount, 0)

  ReceiptStore.receipt.PromotionDiscount = totalDiscount
  console.log('Total Discount:', ReceiptStore.receipt.PromotionDiscount)

  PromotionStore.promotionDialog = false
  ReceiptStore.calReceipt()
  console.log(pointAmountStore)
}
</script>
<template>
  <v-dialog v-model="PromotionStore.promotionDialog" persistent width="auto">
    <div>
      <v-card>
        <v-card-title class="promotions-title">PROMOTION</v-card-title>
        <v-data-table-virtual :items="checkPromotion" :headers="PromotionStore.headers">
          <template v-slot:[`item.actions`]="{ item }">
            <input type="checkbox" v-model="item.selected" />
          </template>
        </v-data-table-virtual>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn class="cancel-button" variant="text" @click="cancelDialog()">Cancel</v-btn>
          <v-btn class="activate-button" variant="text" @click="savePromotions()">Activate</v-btn>
        </v-card-actions>
      </v-card>
    </div>
  </v-dialog>
</template>

<style scoped>
.promotions-title {
  font-size: 30px;
  text-align: center;
  font-weight: bold;
}
.cancel-button {
  color: white;
  background-color: red;
}

.activate-button {
  color: white;
  background-color: green;
}
</style>
